      SUBROUTINE QEDIT
     I                 (MESSFL)
C
C     + + + PURPOSE + + +
C     edit/modify defaulted QUAL2E control parameters
C
C     + + + DUMMY ARGUMENTS + + +
      INTEGER   MESSFL
C
C     + + + ARGUMENT DEFINITIONS + + +
C     MESSFL - Fortran unit number for message file
C
C     + + + COMMON BLOCKS + + +
      INCLUDE 'CQ2VAL.INC'
C
C     + + + LOCAL VARIABLES + + +
      INTEGER     I,J,SCLU,SGRP,RESP
C
C     + + + EXTERNALS + + +
      EXTERNAL   ZSTCMA, QRESP, ZGTRET, QEFUNC, QEDATA, PRNTXT
C
C     + + + END SPECIFICATIONS + + +
C
C     make 'prev' available
      I= 4
      J= 1
      CALL ZSTCMA (I,J)
C
      SCLU= 8
C
 5    CONTINUE
C       continue edit loop
        SGRP= 1
        CALL QRESP (MESSFL,SCLU,SGRP,RESP)
C       get user exit command value
        CALL ZGTRET (I)
        IF (I.EQ.1) THEN
C         user selected 'next', continue with option selected
          GO TO (10,20,30,40), RESP
C
 10       CONTINUE
C           functional parameters
            CALL QEFUNC (MESSFL,SCLU)
            GO TO 100
C
 20       CONTINUE
C           state variables
C           CALL QESTAT (MESSFL,SCLU)
            SGRP= 3
            CALL PRNTXT (MESSFL,SCLU,SGRP)
            GO TO 100
C
 30       CONTINUE
C           data types
            CALL QEDATA (MESSFL)
            GO TO 100
C
 40       CONTINUE
C           all done
            GO TO 100
C
 100      CONTINUE
        END IF
      IF (RESP.NE.4 .AND. I.EQ.1) GO TO 5
C
C     make 'prev' unavailable
      I= 4 
      J= 0
      CALL ZSTCMA (I,J)
C
      RETURN
      END
